
/*********************************************
*                 CRIATECNO                  *
*            www.criatecno.com.br            *
*********************************************/

// Atividade 28 -  Navegação com sensor de infravermelho

#include <Servo.h>
Servo servoDireito;
Servo servoEsquerdo;
int receptorDireito = 7;
int receptorEsquerdo = 9;
int ledDireito = 6;
int ledEsquerdo = 8;
int motorDireito = 5;
int motorEsquerdo = 10;
int nivelReceptorDireito;
int nivelReceptorEsquerdo;
int nivelIR;
int tempoFrente = 20;
int tempoTras = 200;
int tempoDireita = 400;
int tempoEsquerda = 400;
long frequencia = 38000;
void setup() {
  pinMode(receptorDireito, INPUT);
  pinMode(receptorEsquerdo, INPUT);
  pinMode(ledDireito, OUTPUT);
  pinMode(ledEsquerdo, OUTPUT);
  servoDireito.attach(motorDireito);
  servoEsquerdo.attach(motorEsquerdo);
}
void loop() {
  nivelReceptorDireito = detectar(receptorDireito, ledDireito);
  nivelReceptorEsquerdo = detectar(receptorEsquerdo, ledEsquerdo);
  if (nivelReceptorDireito == LOW && nivelReceptorEsquerdo == LOW) {
    servoDireito.writeMicroseconds(1300);
    servoEsquerdo.writeMicroseconds(1700); 
    delay(tempoTras); 
    servoDireito.writeMicroseconds(1300); 
    servoEsquerdo.writeMicroseconds(1300); 
    delay(tempoDireita);
  }
  if (nivelReceptorDireito == LOW && nivelReceptorEsquerdo == HIGH) {
    servoDireito.writeMicroseconds(1300); 
    servoEsquerdo.writeMicroseconds(1700); 
    delay(tempoTras); 
    servoDireito.writeMicroseconds(1700); 
    servoEsquerdo.writeMicroseconds(1700); 
    delay(tempoEsquerda);
  }
  if (nivelReceptorDireito == HIGH && nivelReceptorEsquerdo == LOW) {
    servoDireito.writeMicroseconds(1300); 
    servoEsquerdo.writeMicroseconds(1700); 
    delay(tempoTras); 
    servoDireito.writeMicroseconds(1300); 
    servoEsquerdo.writeMicroseconds(1300); 
    delay(tempoDireita);
  }
  if (nivelReceptorDireito == HIGH && nivelReceptorEsquerdo == HIGH) {
    servoDireito.writeMicroseconds(1700); 
    servoEsquerdo.writeMicroseconds(1300);
    delay(tempoFrente);
  }
}
int detectar(int receptorIR, int ledIR) {
  tone(ledIR, frequencia, 8);
  delay(1);
  nivelIR = digitalRead(receptorIR);
  delay(1);
  return nivelIR;
}
